当前位置: 首页>>代码示例>>C#>>正文


C# Autodesk.GetType方法代码示例

本文整理汇总了C#中Autodesk.GetType方法的典型用法代码示例。如果您正苦于以下问题:C# Autodesk.GetType方法的具体用法?C# Autodesk.GetType怎么用?C# Autodesk.GetType使用的例子?那么恭喜您, 这里精选的方法代码示例或许可以为您提供帮助。您也可以进一步了解该方法所在Autodesk的用法示例。


在下文中一共展示了Autodesk.GetType方法的10个代码示例,这些例子默认根据受欢迎程度排序。您可以为喜欢或者感觉有用的代码点赞,您的评价将有助于系统推荐出更棒的C#代码示例。

示例1: ExportElement

        /// <summary>
        /// Performs the export of elements, including spatial and non-spatial elements.
        /// </summary>
        /// <param name="exporterIFC">The IFC exporter object.</param>
        /// <param name="element ">The element to export.</param>
        public virtual void ExportElement(ExporterIFC exporterIFC, Autodesk.Revit.DB.Element element)
        {
            if (!CanExportElement(exporterIFC, element))
            {
                if (element is RevitLinkInstance && !ExporterCacheManager.ExportOptionsCache.ExportingLink)
                {
                    IDictionary<String, String> options = exporterIFC.GetOptions();
                    bool? bExportLinks = ExportOptionsCache.GetNamedBooleanOption(options, "ExportLinkedFiles");
                    if (bExportLinks.HasValue && bExportLinks.Value == true)
                    {
                        bool bStoreIFCGUID = ExporterCacheManager.ExportOptionsCache.GUIDOptions.StoreIFCGUID;
                        ExporterCacheManager.ExportOptionsCache.GUIDOptions.StoreIFCGUID = true;
                        GUIDUtil.CreateGUID(element);
                        ExporterCacheManager.ExportOptionsCache.GUIDOptions.StoreIFCGUID = bStoreIFCGUID;
                    }
                }
                return;
            }

            //WriteIFCExportedElements
            if (m_Writer != null)
            {
                Category category = element.Category;
                m_Writer.WriteLine(String.Format("{0},{1},{2}", element.Id, category == null ? "null" : category.Name, element.GetType().Name));
            }

            try
            {
                using (ProductWrapper productWrapper = ProductWrapper.Create(exporterIFC, true))
                {
                    ExportElementImpl(exporterIFC, element, productWrapper);
                    ExporterUtil.ExportRelatedProperties(exporterIFC, element, productWrapper);
                }

                // We are going to clear the parameter cache for the element (not the type) after the export.
                // We do not expect to need the parameters for this element again, so we can free up the space.
                if (!(element is ElementType) && !ExporterStateManager.ShouldPreserveElementParameterCache(element))
                    ParameterUtil.RemoveElementFromCache(element);
            }
            catch (System.Exception ex)
            {
                HandleUnexpectedException(ex, exporterIFC, element);
            }
        }
开发者ID:whztt07,项目名称:RevitIFC,代码行数:49,代码来源:Exporter.cs

示例2: ExportElement

        /// <summary>
        /// Performs the export of elements, including spatial and non-spatial elements.
        /// </summary>
        /// <param name="exporterIFC">The IFC exporter object.</param>
        /// <param name="element ">The element to export.</param>
        public virtual void ExportElement(ExporterIFC exporterIFC, Autodesk.Revit.DB.Element element)
        {
            if (!CanExportElement(exporterIFC, element))
                return;

            //WriteIFCExportedElements
            if (m_Writer != null)
            {
                Category category = element.Category;
                m_Writer.WriteLine(String.Format("{0},{1},{2}", element.Id, category == null ? "null" : category.Name, element.GetType().Name));
            }

            try
            {
                using (ProductWrapper productWrapper = ProductWrapper.Create(exporterIFC, true))
                {
                    ExportElementImpl(exporterIFC, element, productWrapper);
                    ExporterUtil.ExportRelatedProperties(exporterIFC, element, productWrapper);
                }

                // We are going to clear the parameter cache for the element (not the type) after the export.
                // We do not expect to need the parameters for this element again, so we can free up the space.
                if (!(element is ElementType) && !ExporterStateManager.ShouldPreserveElementParameterCache(element))
                    ParameterUtil.RemoveElementFromCache(element);
            }
            catch (System.Exception ex)
            {
                HandleUnexpectedException(ex, exporterIFC, element);
            }
        }
开发者ID:whztt07,项目名称:RevitIFC,代码行数:35,代码来源:Exporter.cs

示例3: SendElement

        // Note: Some element does not expose geometry, for example, curtain wall and dimension.
        // In case of a curtain wall, try selecting a whole wall by a window/box instead of a single pick.
        // It will then select internal components and be able to display its geometry.
        //
        public void SendElement(Autodesk.Revit.DB.Element elem)
        {
            if (elem.GetType() ==  typeof(Autodesk.Revit.DB.Element))
             {
            return;
             }
             if (elem is Autodesk.Revit.DB.TextNote)
             {
             sendTextNote(elem);
             }
             if (elem is Autodesk.Revit.DB.View)
             {
             sendViewpoint(elem);
             }
             // if it is a Group. we will need to look at its components.
             if (elem is Autodesk.Revit.DB.Group)
             {

             /* if we add this, the elements of the Group are duplicates
                Autodesk.Revit.DB.Group @group = (Autodesk.Revit.DB.Group)elem;
                Autodesk.Revit.DB.ElementArray members = @group.GetMemberIds;

                MessageBuffer mb = new MessageBuffer();
                mb.add(elem.Id.IntegerValue);
                mb.add(elem.Name);
                sendMessage(mb.buf, MessageTypes.NewGroup);
                foreach (Autodesk.Revit.DB.Element elm in members)
                {
                   SendElement(elm);
                }
                mb = new MessageBuffer();
                sendMessage(mb.buf, MessageTypes.EndGroup);*/
             }

             else
             {

            // not a group. look at the geom data.
             Autodesk.Revit.DB.GeometryElement geom = elem.get_Geometry(mOptions);
            if ((geom != null))
            {
               SendElement(geom, elem);
            }
             }
        }
开发者ID:dwickeroth,项目名称:covise,代码行数:49,代码来源:COVER.cs

示例4: ExportElement

        /// <summary>
        /// Performs the export of elements, including spatial and non-spatial elements.
        /// </summary>
        /// <param name="exporterIFC">The IFC exporter object.</param>
        /// <param name="filterView">The view whose filter visibility settings govern the export.</param>
        /// <param name="element ">The element to export.</param>
        internal void ExportElement(ExporterIFC exporterIFC, Autodesk.Revit.DB.View filterView, Autodesk.Revit.DB.Element element)
        {
            if (!ElementFilteringUtil.ShouldCategoryBeExported(exporterIFC, element))
                return;

            // if we allow exporting parts as independent building elements, then prevent also exporting the host elements containing the parts.
            if (ExporterCacheManager.ExportOptionsCache.ExportPartsAsBuildingElements && PartExporter.CanExportParts(element))
                return;

            //WriteIFCExportedElements
            if (m_Writer != null)
            {
                Category category = element.Category;
                m_Writer.WriteLine(String.Format("{0},{1},{2}", element.Id, category == null ? "null" : category.Name, element.GetType().Name));
            }

            try
            {
                using (IFCProductWrapper productWrapper = IFCProductWrapper.Create(exporterIFC, true))
                {
                    ExportElementImpl(exporterIFC, element, filterView, productWrapper);

                    ExportElementProperties(exporterIFC, element, productWrapper);
                    ExportElementQuantities(exporterIFC, element, productWrapper);
                    if (ExporterCacheManager.ExportOptionsCache.FileVersion == IFCVersion.IFCCOBIE)
                        ExportElementClassifications(exporterIFC, element, productWrapper);
                }
            }
            catch (System.Exception ex)
            {
                HandleUnexpectedException(ex, exporterIFC, element);
            }
        }
开发者ID:whztt07,项目名称:BIM-IFC,代码行数:39,代码来源:Exporter.cs

示例5: ExportElement

        /// <summary>
        /// Performs the export of elements, including spatial and non-spatial elements.
        /// </summary>
        /// <param name="exporterIFC">The IFC exporter object.</param>
        /// <param name="filterView">The view whose filter visibility settings govern the export.</param>
        /// <param name="element ">The element to export.</param>
        public virtual void ExportElement(ExporterIFC exporterIFC, Autodesk.Revit.DB.View filterView, Autodesk.Revit.DB.Element element)
        {
            if (!CanExportElement(exporterIFC, filterView, element))
                return;

            //WriteIFCExportedElements
            if (m_Writer != null)
            {
                Category category = element.Category;
                m_Writer.WriteLine(String.Format("{0},{1},{2}", element.Id, category == null ? "null" : category.Name, element.GetType().Name));
            }

            try
            {
                using (ProductWrapper productWrapper = ProductWrapper.Create(exporterIFC, true))
                {
                    ExportElementImpl(exporterIFC, element, filterView, productWrapper);

                    // Export PropertySet, Quantity (if set) and Classification (or Uniformat for COBIE) here
                    ExportElementProperties(exporterIFC, element, productWrapper);
                    if (ExporterCacheManager.ExportOptionsCache.ExportBaseQuantities && !(ExporterCacheManager.ExportOptionsCache.FileVersion == IFCVersion.IFCCOBIE))
                        ExportElementQuantities(exporterIFC, element, productWrapper);
                    ExportElementClassifications(exporterIFC, element, productWrapper);                     // Exporting ClassificationCode from IFC parameter 
                    if (ExporterCacheManager.ExportOptionsCache.FileVersion == IFCVersion.IFCCOBIE)
                        ExportElementUniformatClassifications(exporterIFC, element, productWrapper);

                }

                // We are going to clear the parameter cache for the element (not the type) after the export.
                // We do not expect to need the parameters for this element again, so we can free up the space.
                if (!(element is ElementType))
                    ParameterUtil.RemoveElementFromCache(element);
            }
            catch (System.Exception ex)
            {
                HandleUnexpectedException(ex, exporterIFC, element);
            }
        }
开发者ID:whztt07,项目名称:RevitCustomIFCexporter,代码行数:44,代码来源:Exporter.cs

示例6: GetLength

        private Double GetLength(Autodesk.AutoCAD.DatabaseServices.DBObject dbobj)
        {
            try
            {
                Double result = 0.0d;

                if (dbobj.GetType().Name == "Polyline")
                {
                    result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Polyline).Length;
                }
                else if (dbobj.GetType().Name == "Line")
                {
                    result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Line).Length;
                }
                else if (dbobj.GetType().Name == "Arc")
                {
                    result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Arc).Length;
                }
                else if (dbobj.GetType().Name == "Circle")
                {
                    result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Circle).Circumference;
                }
                return result;
            }
            catch (System.Exception ex)
            {
                AcadApp.AcaEd.WriteMessage("ERROR: MarkingCalc().GetLength " + ex + "\n");
            }
            return -1.0d;
        }
开发者ID:Lufan,项目名称:Genplan2012,代码行数:30,代码来源:MarkingCalc.cs

示例7: GetArea

 private Double GetArea(Autodesk.AutoCAD.DatabaseServices.DBObject dbobj)
 {
     Double result = 0.0d;
     try
     {
         if (dbobj.GetType().Name == "Polyline")
         {
             result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Polyline).Area;
         }
         else if (dbobj.GetType().Name == "Circle")
         {
             result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Circle).Area;
         }
     }
     catch (System.Exception ex)
     {
         AcadApp.AcaEd.WriteMessage("ERROR: MarkingCalc().GetArea " + ex + "\n");
     }
     return result;
 }
开发者ID:Lufan,项目名称:Genplan2012,代码行数:20,代码来源:MarkingCalc.cs

示例8: ExportElement

        /// <summary>
        /// Performs the export of elements, including spatial and non-spatial elements.
        /// </summary>
        /// <param name="exporterIFC">The IFC exporter object.</param>
        /// <param name="filterView">The view whose filter visibility settings govern the export.</param>
        /// <param name="element ">The element to export.</param>
        internal void ExportElement(ExporterIFC exporterIFC, Autodesk.Revit.DB.View filterView, Autodesk.Revit.DB.Element element)
        {
            //current view only
            if (filterView != null && !ElementFilteringUtil.IsElementVisible(filterView, element))
                return;
            //

            if (!ElementFilteringUtil.ShouldCategoryBeExported(exporterIFC, element))
                return;

            //WriteIFCExportedElements
            if (m_Writer != null)
            {
                Category category = element.Category;
                m_Writer.WriteLine(String.Format("{0},{1},{2}", element.Id, category == null ? "null" : category.Name, element.GetType().Name));
            }

            try
            {
                using (IFCProductWrapper productWrapper = IFCProductWrapper.Create(exporterIFC, true))
                {
                    if (IsElementSupportedExternally(exporterIFC, element))
                    {
                        ExportElementImpl(exporterIFC, element, productWrapper);
                    }
                    else
                        ExporterIFCUtils.ExportElementInternal(exporterIFC, element, productWrapper);

                    ExportElementProperties(exporterIFC, element, productWrapper);
                    ExportElementQuantities(exporterIFC, element, productWrapper);
                }
            }
            catch (System.Exception ex)
            {
                string errMsg = String.Format("IFC error: Exporting element \"{0}\",{1} - {2}", element.Name, element.Id, ex.ToString());
                element.Document.Application.WriteJournalComment(errMsg, true);
            }
        }
开发者ID:whztt07,项目名称:RevitCustomIFCexporter,代码行数:44,代码来源:Exporter.cs

示例9: GetLength

        private Double GetLength(Autodesk.AutoCAD.DatabaseServices.DBObject dbobj)
        {
            Double result = 0.0d;

            if (dbobj.GetType().Name == "Polyline")
            {
                result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Polyline).Length;
            }
            else if (dbobj.GetType().Name == "Line")
            {
                result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Line).Length;
            }
            else if (dbobj.GetType().Name == "Arc")
            {
                result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Arc).Length;
            }
            else if (dbobj.GetType().Name == "Circle")
            {
                result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Circle).Circumference;
            }
            return result;
        }
开发者ID:Lufan,项目名称:Genplan2012,代码行数:22,代码来源:MarkingCalc.xaml.cs

示例10: GetArea

        private Double GetArea(Autodesk.AutoCAD.DatabaseServices.DBObject dbobj)
        {
            Double result = 0.0d;

            if (dbobj.GetType().Name == "Polyline")
            {
                result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Polyline).Area;
            }
            else if (dbobj.GetType().Name == "Circle")
            {
                result = (dbobj as Autodesk.AutoCAD.DatabaseServices.Circle).Area;
            }
            return result;
        }
开发者ID:Lufan,项目名称:Genplan2012,代码行数:14,代码来源:MarkingCalc.xaml.cs


注:本文中的Autodesk.GetType方法示例由纯净天空整理自Github/MSDocs等开源代码及文档管理平台,相关代码片段筛选自各路编程大神贡献的开源项目,源码版权归原作者所有,传播和使用请参考对应项目的License;未经允许,请勿转载。